"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var HtmlDomService = /** @class */ (function () {
    function HtmlDomService() {
    }
    HtmlDomService.prototype.getExpHeight = function (dom) {
        dom.style.visibility = 'hidden';
        var height = dom.clientHeight;
        dom.style.visibility = '';
        return height;
    };
    HtmlDomService.prototype.getPosition = function (dom) {
        var rect = dom.getBoundingClientRect();
        return { x: rect.left, y: rect.top };
    };
    HtmlDomService.prototype.getHeight = function (dom) {
        return dom.clientHeight;
    };
    HtmlDomService.prototype.overflowBottom = function (dom, offset) {
        if (offset === void 0) { offset = 0; }
        var height = dom.clientHeight + offset;
        var position = this.getPosition(dom);
        return window.innerHeight > position.y + height + offset;
    };
    HtmlDomService.prototype.overflowTop = function (dom, offset) {
        if (offset === void 0) { offset = 0; }
        var height = dom.clientHeight + offset;
        var position = this.getPosition(dom);
        return (position.y - height - offset) > 0;
    };
    HtmlDomService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    HtmlDomService.ctorParameters = function () { return []; };
    return HtmlDomService;
}());
exports.HtmlDomService = HtmlDomService;
//# sourceMappingURL=htmldom.service.js.map