import { EventEmitter, ElementRef, OnInit } from '@angular/core';
import { DomAttr } from './../../commons/extends/attr.class';
import { DomLoad } from './../../commons/interfaces/load.interface';
export declare class ButtonDirective extends DomAttr implements OnInit, DomLoad {
    private el;
    private button;
    private icon;
    loading: boolean;
    class: string;
    load: EventEmitter<DomLoad>;
    disabled: boolean;
    readonly _disabled: boolean;
    readonly _class: string;
    onClick(): void;
    /**
     * construnct
     *
     * @param {ElementRef} el Directive target document
     */
    constructor(el: ElementRef);
    /**
     * Directive init hook
     */
    ngOnInit(): void;
    /**
     * Show loading icon
     */
    present(): void;
    /**
     * Remove loading icon
     */
    dismiss(): void;
    /**
     * Check loading icon
     */
    private hasLoadingIcon();
}
