"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var font_awesome_class_1 = require("./../../commons/classes/font-awesome.class");
var attr_class_1 = require("./../../commons/extends/attr.class");
var ButtonDirective = /** @class */ (function (_super) {
    __extends(ButtonDirective, _super);
    /**
     * construnct
     *
     * @param {ElementRef} el Directive target document
     */
    function ButtonDirective(el) {
        var _this = _super.call(this) || this;
        _this.el = el;
        _this.load = new core_1.EventEmitter();
        _this.outline = null;
        _this.lg = null;
        _this.sm = null;
        _this.loading = null;
        _this.icon = new font_awesome_class_1.FontAwesome('spinner', true).toHtmlString();
        return _this;
    }
    Object.defineProperty(ButtonDirective.prototype, "_disabled", {
        get: function () {
            return this.disabled || this.loading === true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ButtonDirective.prototype, "_class", {
        get: function () {
            return this.btnClass + " " + (this.class || '');
        },
        enumerable: true,
        configurable: true
    });
    ButtonDirective.prototype.onClick = function () {
        this.present();
        this.load.emit(this);
    };
    /**
     * Directive init hook
     */
    /**
         * Directive init hook
         */
    ButtonDirective.prototype.ngOnInit = /**
         * Directive init hook
         */
    function () {
        this.button = this.el.nativeElement;
        this.button.type = 'button';
    };
    /**
     * Show loading icon
     */
    /**
         * Show loading icon
         */
    ButtonDirective.prototype.present = /**
         * Show loading icon
         */
    function () {
        if (this.loading !== null && !this.hasLoadingIcon()) {
            this.button.innerHTML = this.icon + this.button.innerHTML;
            this.loading = true;
        }
    };
    /**
     * Remove loading icon
     */
    /**
         * Remove loading icon
         */
    ButtonDirective.prototype.dismiss = /**
         * Remove loading icon
         */
    function () {
        if (this.hasLoadingIcon()) {
            this.button.removeChild(this.button.childNodes[0]);
            this.button.innerHTML = this.button.innerHTML.replace("<!-- " + this.icon + " -->", '');
            this.loading = false;
        }
    };
    /**
     * Check loading icon
     */
    /**
         * Check loading icon
         */
    ButtonDirective.prototype.hasLoadingIcon = /**
         * Check loading icon
         */
    function () {
        return this.button.innerHTML.indexOf("<!-- " + this.icon + " -->") >= 0;
    };
    ButtonDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "button[tsBtn]",
                    exportAs: 'tsBtn'
                },] },
    ];
    /** @nocollapse */
    ButtonDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
    ]; };
    ButtonDirective.propDecorators = {
        "loading": [{ type: core_1.Input },],
        "class": [{ type: core_1.Input },],
        "load": [{ type: core_1.Output },],
        "disabled": [{ type: core_1.Input },],
        "_disabled": [{ type: core_1.HostBinding, args: ['disabled',] },],
        "_class": [{ type: core_1.HostBinding, args: ['class',] },],
        "onClick": [{ type: core_1.HostListener, args: ['click', ['$event'],] },],
    };
    return ButtonDirective;
}(attr_class_1.DomAttr));
exports.ButtonDirective = ButtonDirective;
//# sourceMappingURL=button.directive.js.map