"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var image_config_1 = require("./image.config");
var ImageDirective = /** @class */ (function () {
    function ImageDirective(config) {
        this.config = config;
    }
    ImageDirective.prototype.onError = function (image) {
        this.src = this.dataSrc || this.config.default;
    };
    ImageDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: "img[tsImg]",
                    exportAs: 'tsImg'
                },] },
    ];
    /** @nocollapse */
    ImageDirective.ctorParameters = function () { return [
        { type: image_config_1.ImageConfig, },
    ]; };
    ImageDirective.propDecorators = {
        "dataSrc": [{ type: core_1.Input },],
        "src": [{ type: core_1.HostBinding, args: ['src',] },],
        "onError": [{ type: core_1.HostListener, args: ['error', ['$event.target'],] },],
    };
    return ImageDirective;
}());
exports.ImageDirective = ImageDirective;
//# sourceMappingURL=image.directive.js.map