"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var MenuComponent = /** @class */ (function (_super) {
    __extends(MenuComponent, _super);
    function MenuComponent() {
        var _this = _super.call(this) || this;
        _this.menuActiveChange = new core_1.EventEmitter();
        _this.items = new Array();
        return _this;
    }
    MenuComponent.prototype.toggleGroup = function (group) {
        var tempActive = group.active;
        this.setAllInActive();
        group.active = !tempActive;
    };
    MenuComponent.prototype.toggleMenu = function (group, itemIndex) {
        this.setAllInActive();
        group.active = true;
        group.menuItems[itemIndex].active = true;
        this.menuActiveChange.emit(group.menuItems[itemIndex].url);
    };
    MenuComponent.prototype.setAllInActive = function () {
        this.items.forEach(function (item) {
            item.menuGroups.forEach(function (a) {
                a.active = false;
                a.menuItems.forEach(function (b) {
                    b.active = false;
                });
            });
        });
    };
    MenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "ts-menu",
                    exportAs: 'tsMenu',
                    templateUrl: './menu.component.html',
                    styles: [
                        "\n        .ts-icon{\n            width:30px;\n        }\n        .icon-up {\n            animation: icon-up 0.5s ease-out forwards;\n        }\n        .icon-down {\n            animation: icon-down 0.5s ease-out forwards;\n        }\n        .menu-block {\n            overflow-y: hidden;\n            font-size: 14px;\n            -moz-user-select: none;\n            -webkit-user-select: none;\n            -ms-user-select: none;\n            -khtml-user-select: none;\n            user-select: none;\n            border-left-width:3px;\n            border-left-style:solid;\n            border-left-color:transparent;\n        }\n        .menu-main{\n            line-height:35px;\n        }\n        .menu-child-block{\n            line-height:35px;\n        }\n        .child-close {\n            max-height: 0px;\n            opacity: 0.5;\n            transform-origin: 50% 0%;\n            transition: all 0.5s linear;\n        }\n        .child-open {\n            max-height: 400px;\n            opacity: 1;\n            transform-origin: 50% 0%;\n            transition: all 1.5s linear;\n        }\n        @keyframes icon-up {\n            0% {\n                transform: rotate(0deg);\n            }\n            100% {\n                transform: rotate(180deg);\n            }\n        }\n        @keyframes icon-down {\n            0% {\n                transform: rotate(180deg);\n            }\n            100% {\n                transform: rotate(0deg);\n            }\n        }"
                    ]
                },] },
    ];
    /** @nocollapse */
    MenuComponent.ctorParameters = function () { return []; };
    MenuComponent.propDecorators = {
        "items": [{ type: core_1.Input },],
        "avatars": [{ type: core_1.Input },],
        "menuActiveChange": [{ type: core_1.Output },],
    };
    return MenuComponent;
}(attr_class_1.DomAttr));
exports.MenuComponent = MenuComponent;
//# sourceMappingURL=menu.component.js.map