"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var script_service_1 = require("./../../commons/services/script.service");
var PrismComponent = /** @class */ (function () {
    function PrismComponent(script) {
        this.script = script;
        this.languages = {
            html: Prism.languages.html,
            typescript: Prism.languages.typescript,
            javascript: Prism.languages.javascript,
            xml: Prism.languages.xml,
            php: Prism.languages.php,
        };
        this.language = 'html';
    }
    PrismComponent.prototype.ngOnChanges = function (changes) {
        if (changes.language && changes.code) {
            var language = changes.language.currentValue || 'html';
            var code = Prism.highlight(this.code || '', this.languages[language]);
            var lineLength = code.split('\n').length;
            var lineCode = '<span class="line-numbers-rows">';
            for (var i = 0; i < lineLength; i++) {
                lineCode += '<span></span>';
            }
            lineCode += '</span">';
            this.codePad.nativeElement.innerHTML = "" + code + lineCode;
        }
    };
    PrismComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ts-prism',
                    template: "<pre class=\"line-numbers {{'language-'+language}} rounded-0\"\n                    [ngStyle]=\"codeStyle||{}\"><code class=\"{{'language-'+language}}\" #pad></code></pre>",
                    providers: [
                        script_service_1.ScriptService
                    ],
                },] },
    ];
    /** @nocollapse */
    PrismComponent.ctorParameters = function () { return [
        { type: script_service_1.ScriptService, },
    ]; };
    PrismComponent.propDecorators = {
        "language": [{ type: core_1.Input },],
        "code": [{ type: core_1.Input },],
        "codeStyle": [{ type: core_1.Input },],
        "codePad": [{ type: core_1.ViewChild, args: ['pad',] },],
    };
    return PrismComponent;
}());
exports.PrismComponent = PrismComponent;
//# sourceMappingURL=prism.component.js.map